import python_common.edns.edns as edns
import sys
import time
import pandas as pd 
import dns.resolver
import random
from collections import Counter

GOOGLE = "8.8.8.8"
NU = "165.124.183.74"
TESTER = "66.201.73.5"

def IPcollector(filename,qname,aname):

	fin = open(filename,'r')
	querytemp=open('querytemp.txt','w')
	querydomain=open(qname,'w')
	actualdomain=open(aname,'w')
	querynum=[]
	for line in fin:
		col=line.split()
		if col[7]=='A' or (col[7]=='CNAME' and 'A ' in line) and 'AAAA' not in line:
			if len(querynum) > 0:
				if col[5] not in querynum:
					querynum.append(col[5])     #list of all query numbers contating cnames and A records
			elif len(querynum)==0:
				querynum.append(col[5])
	fin.close()
	fin = open(filename,'r')
	countQ=0
	countA=0
	for line in fin:
		col=line.split()
		for x in range(0,len(querynum)-1):   #iterate through the entire array and look for that query number 
			if querynum[x]==col[5] and col[7]=='CNAME':		 #for picking out the akamai domanin name
				#this loop picks out the final cname for the domain queried 
				for y in range(0,len(col)-1):				
					if col[y]=='A':
						#print "len of querynum before pop: ", len(querynum)
						dname=col[y-1].split(',')
						print querynum[x]+' '+dname[0]
						querydomain.write(querynum[x]+' '+dname[0])
						querytemp.write(querynum[x]+' '+dname[0])
						querydomain.write("\n")
						querytemp.write("\n")
						countQ=countQ+1
						#rem=querynum.pop(x)
						#print "len of querynum: ", len(querynum)
						#print "x inside is ", x
						break
			elif querynum[x]==col[5] and col[7]=='A':
				print "no domain here"
			if querynum[x]+'+'==col[5] and col[6]=='A?':   #for picking out the actual query domain
					actualdomain.write(querynum[x]+' '+col[7])
					actualdomain.write("\n")
					countA=countA+1
					break

	fin.close()
	actualdomain.close()
	querytemp.close()
	print "countA: " ,countA
	print "countQ: " , countQ
	dict={}

	domainactual_list=[]
	actualdomain=open(aname,'r')
	for line in actualdomain:
		col=line.split()
		dict[col[0]]=col[1]
		domainactual_list.append(col[0])

	print "################################################"
	print domainactual_list
	print "################################################"
	print dict


	domainquery_list=[]
	querytemp=open('querytemp.txt','r')
	for line in querytemp:
		col=line.split()
		domainquery_list.append(col[0])
	print "******************************************************"
	print domainquery_list
	print "*******************************************************"

	c_actual=Counter(domainactual_list)
	c_query=Counter(domainquery_list)
	#diff=domainactual_list - domainquery_list
	#diff = [item for item in domainactual_list if not item in domainquery_list]
	diff=c_actual-c_query

	print diff
	diff_list= list(diff.elements())

	for d in diff_list:
		dom=dict[d]
		querydomain.write(d+' '+dom)
		querydomain.write("\n")


	return querynum



def main():

	name = "facebook.com"
	fopen='log_' + name 
	qname= 'domain_forquery_' + name  
	aname= 'domain_actual_' + name 
		#fopen="log_weibo.com"
		#qname="domain_forquery_weibo.com"
		#aname="domain_actual_weibo.com"
	querynum=IPcollector(fopen,qname,aname)

	#............SORTING.....................................

	f = open(qname, 'r')
	# omit empty lines and lines containing only whitespace
	lines = [line for line in f if line.strip()]
	f.close()
	lines.sort()
	#sort domain names on query number
	fout=open(qname,'w')
	for x in range(0,len(lines)):
		fout.write(lines[x])

	fout.close()

	f = open(aname, 'r')
	# omit empty lines and lines containing only whitespace
	lines = [line for line in f if line.strip()]
	f.close()
	lines.sort()
	#sort domain names on query number
	fout=open(aname,'w')
	for x in range(0,len(lines)):
			fout.write(lines[x])

	fout.close()

	#............SORTING DONE..................................

	

if __name__ == "__main__":
	main()
