import json
import pandas as pd
from collections import defaultdict

def form_dict(filename):
	#domain_actualfinal.txt
	dict={}
	domainactual_list=set()
	actualdomain=open(filename,'r')
	for line in actualdomain:
		col=line.split()
		dict[col[0]]=col[1]
		domainactual_list.add(col[0])
	return dict


def get_querynumlist(filename):
	#domain_actualfinal.txt
	query_num=[]
	fopen=open(filename,'r')
	for line in fopen:
		col=line.split()
		query_num.append(col[0])
	return query_num


# gets out the number of Arecord associated with a domain name
def make_recdict(dict,filename,query_num):
#log_cnn.com
#query_num->domain_name
#query_num->find recordnum
	dict_rec={}
	fopen=open(filename,'r')
	for line in fopen:
		col=line.split()
		if col[5] in query_num and (col[7]== 'CNAME' or col[7]=='A'):
			num=col[6].split("/")
			dom=dict[col[5]]
			dict_rec[dom]=num[0]

	return dict_rec


#gets number of IPs associated with a domain name
def make_IPdict(filename):
	ip_list=[]
	domain_list=[]
	tempd=[]
	fopen=open(filename,'r')
	for line in fopen:
		#for gettin the domain names
		if ',' in line:
			col=line.split(',')
			x=0
			while x < len(col):
				tempd.append(col[x])
				x=x+1
			rem=tempd.pop() #remove last empty space in every line containing domains
			domain_list.append(tempd)
			tempd=[]
		else:
			ip_list.append(line)
	space=ip_list.pop() #remove last empty space
	f=open('IPs.txt','r')
	count=[]
	for line in f:
		count.append(int(line))
	i=0
	runner=0
	templ=[]
	new_iplist=[]
	for x in ip_list:
		counter=count[i]
		runner=runner+1
		templ.append(x)
		if runner==counter:
			i=i+1
			runner=0
			new_iplist.append(templ)
			templ=[]
	dict={}
	#print domain_list
	print len(domain_list)
	print len(new_iplist)
	for i in range(0,len(domain_list)):
		index_length=len(domain_list[i])
		x=0
		while x < index_length:
			dict[domain_list[i][x]]=new_iplist[i]
			x=x+1
	return dict

def final_dict(dict_rec,dict_IP):
	dd=defaultdict(list)
	for d in (dict_rec,dict_IP):
		for key, value in d.iteritems():
			dd[key].append(value)
	return dd

def main():
	dict=form_dict('domain_actualfinal.txt')
	query_num=get_querynumlist('domain_actualfinal.txt')
	dict_rec=make_recdict(dict,'log_cnn.com',query_num)
	dict_IP=make_IPdict('FinalIPlist_cnn.txt')
	dd=final_dict(dict_rec,dict_IP)
	with open('dict.json',  'w') as f:
		json.dump(dd, f)
	print dd




if __name__ == "__main__":
	main()